package th.co.ais.ssbsrfc.instance;

import th.co.ais.ssbsrfc.config.Constant;
import th.co.ais.ssbsrfc.utils.Global;
import ais.mmt.sand.comlog.SummaryLogPrototype;
import ec02.af.data.EquinoxRawData;


public class BackupSummary {
	private int flow = -1;
	private long requestTimestamp = -1;
	private String initialInvoke = null;
	private String resultCode = null;
	private String resultDescription = null;
	private SummaryLogPrototype sumLog = null;
	
	public BackupSummary() {
		super();
	}
	public void backup(EC02Instance ec02Instance, EquinoxRawData equinoxRawData) {
		AFInstance ins = ec02Instance.getAFInstance();
		this.flow = ins.getFlow();
		this.requestTimestamp = Global.currentInputDateTime;
		this.initialInvoke = ins.getInitialInvoke();
		this.resultCode = ins.getResultCode();
		this.resultDescription = ins.getResultDescription();
		this.sumLog = ins.getSumlog();
		
		String input = Global.inputTimeStamp;
		long reqTimestamp = Global.convertTocurrentTimeMillis(input);
		String invoke = (equinoxRawData != null) ? equinoxRawData.getInvoke() : "";
		
		ec02Instance.getAFInstance().setForceFlow(Constant.FLOW_Unexpected_Event_Handling);
		Global.currentInputDateTime = reqTimestamp;
		ec02Instance.getAFInstance().setForceInitialInvoke(invoke);
		ec02Instance.getAFInstance().setResultCode(null);
		ec02Instance.getAFInstance().setResultDescription(null);
		ec02Instance.getAFInstance().setSumlog(null);
	}
	public void restore(EC02Instance ec02Instance) {
		ec02Instance.getAFInstance().setForceFlow(this.flow);
		Global.currentInputDateTime = this.requestTimestamp;
		ec02Instance.getAFInstance().setForceInitialInvoke(this.initialInvoke);
		ec02Instance.getAFInstance().setResultCode(this.resultCode);
		ec02Instance.getAFInstance().setResultDescription(this.resultDescription);
		ec02Instance.getAFInstance().setSumlog(this.sumLog);
	}
	public int getFlow() {
		return flow;
	}
	public void setFlow(int flow) {
		this.flow = flow;
	}
	public long getRequestTimestamp() {
		return requestTimestamp;
	}
	public void setRequestTimestamp(long requestTimestamp) {
		this.requestTimestamp = requestTimestamp;
	}
	public String getInitialInvoke() {
		return initialInvoke;
	}
	public void setInitialInvoke(String initialInvoke) {
		this.initialInvoke = initialInvoke;
	}
	public String getResultCode() {
		return resultCode;
	}
	public void setResultCode(String resultCode) {
		this.resultCode = resultCode;
	}
	public String getResultDescription() {
		return resultDescription;
	}
	public void setResultDescription(String resultDescription) {
		this.resultDescription = resultDescription;
	}
	public SummaryLogPrototype getSumLog() {
		return sumLog;
	}
	public void setSumLog(SummaryLogPrototype sumLog) {
		this.sumLog = sumLog;
	}
}
