package th.co.ais.ssbsrfc.instance;

import th.co.ais.ssbsrfc.message.MessageParser;
import th.co.ais.ssbsrfc.utils.Global;

import com.google.gson.Gson;

import ec02.utils.AppLog;

public class ResIns 
{
	private String method = null;
	private String resultCode = "";
	private String resultDescription = "";
	private String command = null;
	
	public ResIns () {}
	
	public ResIns(String resultCode, String resultDescription) {
		super();
		this.resultCode = resultCode;
		this.resultDescription = resultDescription;
	}

	public ResIns (String code, String desc, String cmd) {
		this.resultCode = code;
		this.resultDescription = desc;
		this.command = cmd;
	}
	
	public ResIns(String strJson) {
		try {
			Gson gson = new Gson();
			ResIns ins = gson.fromJson(strJson, ResIns.class);
			this.resultCode = ins.getResultCode();
			this.resultDescription = ins.getResultDescription();
			if (ins.getCommand() != null) {
				this.command = ins.getCommand();
			}
		} catch (Exception e) {
			AppLog.e("## EXCEPTION :" + e.getMessage());
		}
	}

	@Override
	public String toString() {
		return Global.unescapePrintString(MessageParser.toJson(this));
	}

	public String getResultCode() {
		return resultCode;
	}
	public void setResultCode(String resultCode) {
		this.resultCode = resultCode;
	}
	public String getResultDescription() {
		return resultDescription;
	}
	public void setResultDescription(String resultDescription) {
		this.resultDescription = resultDescription;
	}

	public String getCommand() {
		return command;
	}

	public void setCommand(String command) {
		this.command = command;
	}

	public String getMethod() {
		return method;
	}

	public void setMethod(String method) {
		this.method = method;
	}
	
}
