package th.co.ais.ssbsrfc.instance;

import com.sun.xml.internal.bind.marshaller.NamespacePrefixMapper;


public class SOAPNamespaceMapper extends NamespacePrefixMapper {

	private static final String SOAPENV_PREFIX = "soapenv"; // DEFAULT NAMESPACE
	private static final String SOAPENV_URI = "http://schemas.xmlsoap.org/soap/envelope/";

	private static final String CBS_PREFIX = "cbs";
	private static final String CBS_URI = "http://www.huawei.com/bme/cbsinterface/cbscommon";
	
	private static final String ARS_PREFIX = "ars";
	private static final String ARS_URI = "http://www.huawei.com/bme/cbsinterface/arservices";
	
	private static final String ARC_PREFIX = "arc"; 
	private static final String ARC_URI = "http://cbs.huawei.com/ar/wsservice/arcommon";
	
	
	@Override
	public String getPreferredPrefix(String namespaceUri, String suggestion, boolean requirePrefix) {
		if(SOAPENV_URI.equals(namespaceUri)) {
			return SOAPENV_PREFIX;
		} else if(ARC_URI.equals(namespaceUri)) {
			return ARC_PREFIX;
		} else if(ARS_URI.equals(namespaceUri)) {
			return ARS_PREFIX;
		} else if(CBS_URI.equals(namespaceUri)) {
			return CBS_PREFIX;
		}
		return suggestion;
	}

	
}
