package th.co.ais.ssbsrfc.state;

import java.util.ArrayList;

import th.co.ais.ssbsrfc.instance.EC02Instance;
import ec02.af.abstracts.AbstractAF;
import ec02.af.data.EquinoxProperties;
import ec02.af.data.EquinoxRawData;
import ec02.af.interfaces.IAFState;
import ec02.utils.AppLog;

public class StateWaitE11Timeout implements IAFState {
	
	private String eqxState = null;
	private ArrayList<EquinoxRawData> eqxRawDataList = new ArrayList<EquinoxRawData>();

	@Override
	public String doAction(AbstractAF abstractAF, Object instance, ArrayList<EquinoxRawData> eqxRawDataList) {
		EC02Instance ec02Instance = (EC02Instance) instance;
		for(EquinoxRawData equinoxRawData : eqxRawDataList) {
			String eventType = equinoxRawData.getRawEventType();
			AppLog.d("## EVENTTYPE :" + eventType);
		}
		// TIMEOUT
		EquinoxProperties eqxProp = ec02Instance.getEquinoxProperties();
		String diag = eqxProp.getDiag();
		if (diag.equals("Timeout")) {
			AppLog.d("## RET:4 DIAG:TIMEOUT");
		}
		ec02Instance.setEqxRawDataList(this.eqxRawDataList);
		return this.eqxState;
	}

}
