package th.co.ais.ssbsrfc.substate;

import th.co.ais.ssbsrfc.config.Constant;
import th.co.ais.ssbsrfc.config.StateConfig;
import th.co.ais.ssbsrfc.instance.EC02Instance;
import th.co.ais.ssbsrfc.instance.EQXRawInstance;
import th.co.ais.ssbsrfc.utils.EqxStringUtils;
import ec02.af.abstracts.AbstractAF;
import ec02.af.data.EquinoxRawData;
import ec02.utils.AppLog;


public class SubWaitA extends WaitSubState {
	public void configSubstate(EC02Instance ec02Instance, EquinoxRawData equinoxRawData)
	{
		this._state = StateConfig.SSTATE_W_A;
		this._eventType = StateConfig.Incoming_A_Request;
		this._stateType = Constant.SUBSTATE_TYPE_W_REQUEST;
		if (equinoxRawData != null) {
			ec02Instance.getAFInstance().setOrig(equinoxRawData.getOrig());
			ec02Instance.getAFInstance().setInvoke(equinoxRawData.getInvoke());
			ec02Instance.getAFInstance().setInitialInvoke(equinoxRawData.getInvoke());
		}
		ec02Instance.getAFInstance().setFlow(Constant.FLOW_TEST_A);
	}

	public Object getMessage(EC02Instance ec02Instance, EquinoxRawData equinoxRawData)
	{ 
		String value = EqxStringUtils.getMessage(equinoxRawData, ec02Instance);
		AppLog.d("## PARAMETERS : " + value);
		return value;
	}

	public void verifyMessage(AbstractAF abstractAF, EC02Instance ec02Instance, EquinoxRawData equinoxRawData) 
	{ 
		AppLog.d("## TEST MSG SUBSTATE A");
		this.type = Constant.TYPE_SUCCESS;
	}
	public void buildMessage(AbstractAF abstractAF, EC02Instance ec02Instance, EquinoxRawData equinoxRawData) 
	{ 
		switch (this.type) {
			case Constant.TYPE_SUCCESS:
			default:
			{
//				this.isStat = false;
//				ec02Instance.getAFInstance().getListStat().add(new Stat(StateConfig.PROJECT_STAT_NAME + " ABCDEFG STAT"));
				
				ec02Instance.getAFInstance().setCurrentState(StateConfig.SSTATE_END);
				EQXRawInstance eqxRaw = SubMessages.getRawAResponse(abstractAF, ec02Instance, ec02Instance.getAFInstance().getOrig(), ec02Instance.getAFInstance().getInvoke(),"xx");
				this.equinoxRawDataList.add(this.ec02Builder.getHTTPResponse(eqxRaw));
			}
		}
	}
}
